<?php

/**
 * This is a WHMCS Registrar Module
 * Bangmod.Cloud WHMCS .TH Domain Reseller Module
 * BangmodCloudTHDomain
 *
 * @copyright Bangmod Enterprise Co., Ltd.
 * @developer @chakree30584
 *
 */
if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}

function bangmodcloudthdomain_MetaData() {
    return array(
        'DisplayName' => 'Bangmod.Cloud .TH Domain Reseller Module',
        'APIVersion' => '1.0',
    );
}

function bangmodcloudthdomain_api($params) {
    $url = "https://nest.bangmod.cloud/domain/api/whcms_api"; # URL to Bangmod.Cloud Reseller API
    $params["email"] = $params["E-mail"];
    $params["api_key"] = $params["API_Key"];
    unset($params["E-mail"]);
    unset($params["API Key"]);
    $params = array('params' => json_encode($params));

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT, 100);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
    $data = curl_exec($ch);
    curl_close($ch);

    $results = json_decode($data, true);
    return $results;
}

function bangmodcloudthdomain_getConfigArray() {
    $configarray = array(
        'FriendlyName' => array(
            'Type' => 'System',
            'Value' => 'Bangmod.Cloud .TH Domain Reseller Module',
        ),
        "E-mail" => array(
            "Type" => "text",
            "Size" => "60",
            "Description" => "Enter your Bangmod.Cloud User Account E-mail here"
        ),
        "API_Key" => array(
            "Type" => "password",
            "Size" => "50",
            "Description" => "Enter your Bangmod.Cloud WHMCS .TH Domain Reseller Module API Key here"
        )
    );
    return $configarray;
}

function bangmodcloudthdomain_GetNameservers($params) {
    $params["action"] = "GetNameservers";
    $values = bangmodcloudthdomain_api($params);
    return $values;
}

function bangmodcloudthdomain_SaveNameservers($params) {
    $params["action"] = "SaveNameservers";
    $values = bangmodcloudthdomain_api($params);
    return $values;
}

function bangmodcloudthdomain_RegisterDomain($params) {
    $params["action"] = "RegisterDomain";
    $values = bangmodcloudthdomain_api($params);
    return $values;
}

function bangmodcloudthdomain_RenewDomain($params) {
    $params["action"] = "RenewDomain";
    $values = bangmodcloudthdomain_api($params);
    return $values;
}

function bangmodcloudthdomain_TransferSync($params) {
    $params['action'] = "TransferSync";
    $values = bangmodcloudthdomain_api($params);
    return $values;
}

function bangmodcloudthdomain_Sync($params) {
    $params['action'] = 'Sync';
    return bangmodcloudthdomain_api($params);
}